constant_time.h File Reference
`#include <stddef.h>`
Include dependency graph for constant_time.h:

Go to the source code of this file.

## Functions

int | mbedtls_ct_memcmp (const void *a, const void *b, size_t n)

## Function Documentation

## mbedtls_ct_memcmp()

int mbedtls_ct_memcmp | ( | const void * | a,
|  | const void * | b,
|  | size_t | n
| ) |  |

Constant-time functions

Copyright The Mbed TLS Contributors SPDX-License-Identifier: Apache-2.0

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. Constant-time buffer comparison without branches.

This is equivalent to the standard memcmp function, but is likely to be compiled to code using bitwise operation rather than a branch.

This function can be used to write constant-time code by replacing branches with bit operations using masks.

Parameters

  a | Pointer to the first buffer.
  b | Pointer to the second buffer.
  n | The number of bytes to compare in the buffer.

Returns
  Zero if the content of the two buffer is the same, otherwise non-zero.